#!/bin/sh

SSROOT=/mod/screensaver

if [ -f /mod/etc/screensaver.conf ]; then
  while read key value ; do
    export "screensaver_$key=${value//\"/}"
  done < /mod/etc/screensaver.conf
fi
        
rana=`hexdump -v -n 2 -o /dev/urandom | sed -e 's/^[0-9]\+ //' -e 's/ \+//' -e 2d`

count=0
for d in $SSROOT/*; do
  [ "$d" == "$SSROOT/Random" -o "$d" == "$SSROOT/$screensaver_random" ] && continue
  for x in $d/*; do
      [ "$x" = "$d/*" ] && continue 2
      break
  done
  echo $((count++)) > /dev/null
done
ranb=$(( 0$rana % $count ))
                    
count=0
for d in $SSROOT/*; do
  [ "$d" == "$SSROOT/Random" -o "$d" == "$SSROOT/$screensaver_random" ] && continue
  for x in $d/*; do
      [ "$x" = "$d/*" ] && continue 2
      break
  done
  if [ $count -eq $ranb ]; then
    ss="${d##*/}"
    break
  fi
  echo $((count++)) > /dev/null
done

screensaver_random="$ss"
[ "$screensaver_selected" == "Random" ] &&  /mod/bin/screensaver -n "$ss"

set | grep "^screensaver_" | sed -e 's/=/ /' -e s/\'/\"/g -e 's/^screensaver_//' > /mod/etc/screensaver.conf

